Index: squid/auth_modules/SMB/smb_auth.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/auth_modules/SMB/Attic/smb_auth.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/auth_modules/SMB/smb_auth.c	26 Jan 2000 03:23:09 -0000	1.1.1.1
+++ squid/auth_modules/SMB/smb_auth.c	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -27,16 +27,52 @@
 
 struct SMBDOMAIN
 {
-	char				*name;		/* domain name */
-	char				*sname;		/* match this with user input */
-	char				*nmbaddr;	/* name service address */
-	int					nmbcast;	/* broadcast or unicast */
-	struct SMBDOMAIN	*next;		/* linked list */
+	char				*name;			/* domain name */
+	char				*sname;			/* match this with user input */
+	char				*passthrough;	/* pass-through authentication */
+	char				*nmbaddr;		/* name service address */
+	int					nmbcast;		/* broadcast or unicast */
+	char				*authshare;		/* share name of auth file */
+	char				*authfile;		/* pathname of auth file */
+	struct SMBDOMAIN	*next;			/* linked list */
 };
 
 struct SMBDOMAIN *firstdom = NULL;
 struct SMBDOMAIN *lastdom = NULL;
 
+/*
+ * escape the backslash character, since it has a special meaning
+ * to the read command of the bourne shell.
+ */
+
+void print_esc(FILE *p, char *s)
+{
+	char	buf[256];
+	char	*t;
+	int		i = 0;
+
+	for (t = s; *t != '\0'; t++)
+	{
+		if (i > 250)
+		{
+			buf[i] = '\0';
+			(void) fputs(buf, p);
+			i = 0;
+		}
+
+		if (*t == '\\')
+			buf[i++] = '\\';
+
+		buf[i++] = *t;
+	}
+
+	if (i > 0)
+	{
+		buf[i] = '\0';
+		(void) fputs(buf, p);
+	}
+}
+
 void main(int argc, char *argv[])
 {
 	int					i;
@@ -47,6 +83,8 @@
 	char				*pass;
 	char				*domname;
 	FILE				*p;
+	int					debug = 0;
+	char				*shcmd;
 
 	/* make standard output line buffered */
 	if (setvbuf(stdout, NULL, _IOLBF, 0) != 0)
@@ -55,6 +93,12 @@
 	/* parse command line arguments */
 	for (i = 1; i < argc; i++)
 	{
+		if (strcmp(argv[i], "-d") == 0)
+		{
+			debug = 1;
+			continue;
+		}
+
 		/* the next options require an argument */
 		if (i + 1 == argc)
 			break;
@@ -65,8 +109,11 @@
 				return;
 
 			dom->name = dom->sname = argv[++i];
+			dom->passthrough = "";
 			dom->nmbaddr = "";
 			dom->nmbcast = NMB_BROADCAST;
+			dom->authshare = "NETLOGON";
+			dom->authfile = "proxyauth";
 			dom->next = NULL;
 
 			/* append to linked list */
@@ -86,6 +133,13 @@
 			continue;
 		}
 
+		if (strcmp(argv[i], "-P") == 0)
+		{
+			if (lastdom != NULL)
+				lastdom->passthrough = argv[++i];
+			continue;
+		}
+
 		if (strcmp(argv[i], "-B") == 0)
 		{
 			if (lastdom != NULL)
@@ -105,8 +159,39 @@
 			}
 			continue;
 		}
+
+		if (strcmp(argv[i], "-S") == 0)
+		{
+			if (lastdom != NULL)
+			{
+				if ((lastdom->authshare = strdup(argv[++i])) == NULL)
+					return;
+
+				/* convert backslashes to forward slashes */
+				for (s = lastdom->authshare; *s != '\0'; s++)
+					if (*s == '\\')
+						*s = '/';
+
+				/* strip leading forward slash from share name */
+				if (*lastdom->authshare == '/')
+					lastdom->authshare++;
+
+				if ((s = strchr(lastdom->authshare, '/')) != NULL)
+  				{
+  					*s = '\0';
+  					lastdom->authfile = s + 1;
+  				}
+			}
+			continue;
+		}
 	}
 
+	shcmd = debug ? HELPERSCRIPT : HELPERSCRIPT " > /dev/null 2>&1";
+
+	/* pass to helper script */
+    if (putenv("SAMBAPREFIX=" SAMBAPREFIX) != 0)
+    	return;
+
 	while (1)
 	{
 		if (fgets(buf, BUFSIZE, stdin) == NULL)
@@ -149,18 +234,22 @@
 			continue;
 		}
 
-		if ((p = popen(HELPERSCRIPT " > /dev/null 2>&1", "w")) == NULL)
+		if ((p = popen(shcmd, "w")) == NULL)
 		{
 			(void) printf("ERR\n");
 			continue;
 		}
 
-		(void) fprintf(p, "%s\n", SAMBAPREFIX);
 		(void) fprintf(p, "%s\n", dom->name);
+		(void) fprintf(p, "%s\n", dom->passthrough);
 		(void) fprintf(p, "%s\n", dom->nmbaddr);
 		(void) fprintf(p, "%d\n", dom->nmbcast);
+		(void) fprintf(p, "%s\n", dom->authshare);
+		(void) fprintf(p, "%s\n", dom->authfile);
 		(void) fprintf(p, "%s\n", user);
-		(void) fprintf(p, "%s\n", pass);
+		/* the password can contain special characters */
+		print_esc(p, pass);
+		(void) fputc('\n', p);
 		(void) fflush(p);
 
 		if (pclose(p) == 0)
Index: squid/doc/Programming-Guide/prog-guide.sgml
===================================================================
RCS file: /cvsroot/squid-sf//squid/doc/Programming-Guide/prog-guide.sgml,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/doc/Programming-Guide/prog-guide.sgml	26 Jan 2000 03:23:10 -0000	1.1.1.1
+++ squid/doc/Programming-Guide/prog-guide.sgml	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -1,6 +1,6 @@
 <!doctype linuxdoc system>
 <article>
-<title>Squid v1.2 Programmers Guide</title>
+<title>Squid Programmers Guide</title>
 <author>Duane Wessels, Squid Developers
 
 <abstract>
@@ -18,236 +18,184 @@
 <!-- %%%% Chapter : INTRODUCTION %%%% -->
 <sect>Introduction
 
-<P>
-The Squid source code has evolved more from empirical observation and
-tinkering, rather than a solid design process.  It carries a legacy of
-being ``touched'' by numerous individuals, each with somewhat different
-techniques and terminology.  
-
-<P>
-Squid is a single-process proxy server.  Every request is handled by
-the main process, with the exception of FTP.  However, Squid does not
-use a ``threads package'' such has Pthreads.  While this might be 
-easier to code, it suffers from portability and performance problems.
-Instead Squid maintains data structures and state information for
-each active request.
-
-<P>
-The code is often difficult to follow because there are no explicit
-state variables for the active requests.  Instead, thread execution
-progresses as a sequence of ``callback functions'' which get executed
-when I/O is ready to occur, or some other event has happened.  As
-a callback function completes, it is responsible for registering the
-next callback function for subsequent I/O.
-
-<P>
-Note there is only a pseudo-consistent naming scheme.  In most 
-cases functions are named like <tt/moduleFooBar()/.  However, there
-are also some functions named like <tt/module_foo_bar()/.
-
-<P>
-Note that the Squid source changes rapidly, and some parts of this
-document may become out-of-date.  If you find any inconsistencies, please
-feel free to notify
-<url url="mailto:squid-dev@nlanr.net"
-name="the Squid Developers">.
+	<P>
+	The Squid source code has evolved more from empirical
+	observation and tinkering, rather than a solid design
+	process.  It carries a legacy of being ``touched'' by
+	numerous individuals, each with somewhat different techniques
+	and terminology.
+
+	<P>
+	Squid is a single-process proxy server.  Every request is
+	handled by the main process, with the exception of FTP.
+	However, Squid does not use a ``threads package'' such has
+	Pthreads.  While this might be easier to code, it suffers
+	from portability and performance problems.  Instead Squid
+	maintains data structures and state information for each
+	active request.
+
+	<P>
+	The code is often difficult to follow because there are no
+	explicit state variables for the active requests.  Instead,
+	thread execution progresses as a sequence of ``callback
+	functions'' which get executed when I/O is ready to occur,
+	or some other event has happened.  As a callback function
+	completes, it is responsible for registering the next
+	callback function for subsequent I/O.
+
+	<P>
+	Note there is only a pseudo-consistent naming scheme.  In
+	most cases functions are named like <tt/moduleFooBar()/.
+	However, there are also some functions named like
+	<tt/module_foo_bar()/.
+
+	<P>
+	Note that the Squid source changes rapidly, and some parts
+	of this document may become out-of-date.  If you find any
+	inconsistencies, please feel free to notify <url
+	url="mailto:squid-dev@nlanr.net" name="the Squid Developers">.
 
 <sect1>Conventions
 
-<P>
-Function names and file names will be written in a courier font, such
-as <tt/store.c/ and <tt/storeRegister()/.  Data structures and their
-members will be written in an italicized font, such as <em/StoreEntry/.
+	<P>
+	Function names and file names will be written in a courier
+	font, such as <tt/store.c/ and <tt/storeRegister()/.  Data
+	structures and their members will be written in an italicized
+	font, such as <em/StoreEntry/.
 
-<sect1>The Big Picture
 
-<P>
+<sect>Overview of Squid Components
+
+	<P>
 Squid consists of the following major components
 
-<sect2>Client Side
+<sect1>Client Side
 
-<P>
-<em/Files:/ <tt/client_side.c/
-
-<P>
-    Here new client connections are accepted, parsed, and processed.
-    This is where we determine if the request is a cache HIT,
-    REFRESH, MISS, etc.  With HTTP/1.1 we may have multiple requests
-    from a single TCP connection.  Per-connection state information
-    is held in a data structure called <em/ConnStateData/.  Per-request
-    state information is stored in the <em/clientHttpRequest/ structure.
+	<P>
+	Here new client connections are accepted, parsed, and
+	processed.  This is where we determine if the request is
+	a cache HIT, REFRESH, MISS, etc.  With HTTP/1.1 we may have
+	multiple requests from a single TCP connection.  Per-connection
+	state information is held in a data structure called
+	<em/ConnStateData/.  Per-request state information is stored
+	in the <em/clientHttpRequest/ structure.
     
-<sect2>Server Side
-
-<P>
-<em/Files:/
-    <tt/proto.c/,
-    <tt/http.c/,
-    <tt/ftp.c/,
-    <tt/gopher.c/,
-    <tt/wais.c/,
-    <tt/ssl.c/,
-    <tt/pass.c/
-
-<P>
-    These routines are responsible for forwarding cache misses
-    to other servers, depending on the protocol.  Cache misses
-    may be forwarded to either origin servers, or other proxy caches.
-    Note that all requests (FTP, Gopher) to other
-    proxies are sent as HTTP requests.  
-    <tt/gopher.c/ is somewhat complex and gross because it must
-    convert from the Gopher protocol to HTTP.  Wais and Gopher don't
-    receive much attention because they comprise a relatively insignificant
-    portion of Internet traffic.
-
-<P>
-    <tt/ssl.c/ handles SSL requests (the CONNECT method) and
-    <tt/pass.c/ (``passthrough'') handles uncachable requests which
-    the cache doesn't really care about.   These two modules basically
-    pass bits back and forth between client and server.  Note they do
-    not use a <em/StoreEntry/ to do so.  About the only difference
-    between the two is that the SSL module sends a special ``connection
-    established'' message.
-
-<sect2>Storage Manager
-
-<P>
-<em/Files:/
-    <tt/store_clean.c/,
-    <tt/store_client.c/,
-    <tt/store_dir.c/,
-    <tt/store_key_md5.c/,
-    <tt/store_log.c/,
-    <tt/store_rebuild.c/,
-    <tt/store_swapin.c/,
-    <tt/store_swapmeta.c/,
-    <tt/store_swapout.c/,
-    <tt/store.c/
-
-<P>
-    The Storage Manager is the glue between client and server sides.
-    Every object saved in the cache is allocated a <em/StoreEntry/
-    structure.  While the object is being accessed, it also has a 
-    <em/MemObject/ structure.
-
-<P>
-    Squid can quickly locate cached objects because it keeps (in memory) a hash
-    table of all <em/StoreEntry/'s.  The keys for the hash
-    table are MD5 checksums of the objects URI.  In addition there is
-    also a doubly-linked list of <em/StoreEntry/'s used for the LRU
-    replacement algorithm.  When an entry is accessed, it is moved to
-    the head of the LRU list.  When Squid needs to replace cached objects,
-    it takes objects from the tail of the LRU list.
-
-<P>
-    Objects are saved to disk in a two-level directory structure.  For
-    each object the <em/StoreEntry/ includes a 4-byte <em/fileno/
-    field.  This file number is converted to a disk pathname by a
-    simple algorithm which evenly distributes the files across all 
-    cache directories.  A cache swap file consists of two parts:
-    the cache metadata, and the object data.  Note the object 
-    data includes the full HTTP reply---headers and body.  The HTTP
-    reply headers are not the same as the cache metadata.
-
-<P>
-    Client-side requests register themselves with a <em/StoreEntry/
-    to be notified when new data arrives.  Multiple clients may
-    receive data via a single <em/StoreEntry/.  For POST and
-    PUT request, this process works in reverse.  Server-side functions
-    are notified when additional data is read from the client.
-
-<sect2>Peer Selection
-
-<P>
-<em/Files:/
-	<tt/peer_select.c/
-
-<P>
-    These functions are responsible for selecting
-    one (or none) of the neighbor caches as the appropriate forwarding
-    location.
-
-<sect2>Access Control
-
-<P>
-<em/Files:/
-	<tt/acl.c/
+<sect1>Server Side
 
-<P>
-    These functions are responsible for allowing
-    or denying a request, based on a number of different parameters.
-    These parameters include the client's IP address, the hostname
-    of the requested resource, the request method, etc.
-    Some of the necessary information may not be immediately available,
-    for example the origin server's IP address.  In these cases, 
-    the ACL routines initiate lookups for the necessary information and
-    continues the access control checks when the information is
-    available.
-
-<sect2>Network Communication
-
-<P>
-<em/Files:/
-	<tt/comm.c/
-
-<P>
-    These are the routines for communicating over
-    TCP and UDP network sockets.  Here is where sockets are opened,
-    closed, read, and written.  In addition, note that the heart of
-    Squid (<tt/comm_select()/ or <tt/comm_poll()/) exists here, even
-    though it handles all file descriptors, not just network sockets.
-    These routines do not support queuing multiple
-    blocks of data for writing.  Consequently, a callback occurs
-    for every write request.
-
-<sect2>File/Disk I/O
-
-<P>
-<em/Files:/
-	<tt/disk.c/
-
-<P>
-    Routines for reading and writing disk files (and FIFOs).
-    Reasons for separating network and
-    disk I/O functions are partly historical, and partly because of
-    different behaviors.  For example, we don't worry about getting a
-    ``No space left on device'' error for network sockets.  The disk
-    I/O routines support queuing of multiple blocks for writing.
-    In some cases, it is possible to merge multiple blocks into
-    a single write request.  The write callback does not necessarily
-    occur for every write request.
-
-<sect2>Neighbors
-
-<P>
-<em/Files:/
-	<tt/neighbors.c/
-
-<P>
-    Maintains the list of neighbor caches.  Sends and receives 
-    ICP messages to neighbors.  Decides which neighbors to
-    query for a given request.  File: <tt/neighbors.c/.
-
-<sect2>IP/FQDN Cache
-
-<P>
-<em/Files:/
-	<tt/ipcache.c/, <tt/fqdncache.c/
-
-<P>
-    A cache of name-to-address and address-to-name lookups.  These are
-    hash tables keyed on the names and addresses.
-    <tt/ipcache_nbgethostbyname()/ and <tt/fqdncache_nbgethostbyaddr()/
-    implement the non-blocking lookups.  Files: <tt/ipcache.c/,
-    <tt/fqdncache.c/.
-
-<sect2>Cache Manager
+	<P>
+	These routines are responsible for forwarding cache misses
+	to other servers, depending on the protocol.  Cache misses
+	may be forwarded to either origin servers, or other proxy
+	caches.  Note that all requests (FTP, Gopher) to other
+	proxies are sent as HTTP requests.  <tt/gopher.c/ is somewhat
+	complex and gross because it must convert from the Gopher
+	protocol to HTTP.  Wais and Gopher don't receive much
+	attention because they comprise a relatively insignificant
+	portion of Internet traffic.
+
+<sect1>Storage Manager
+
+	<P>
+	The Storage Manager is the glue between client and server
+	sides.  Every object saved in the cache is allocated a
+	<em/StoreEntry/ structure.  While the object is being
+	accessed, it also has a <em/MemObject/ structure.
+
+	<P>
+	Squid can quickly locate cached objects because it keeps
+	(in memory) a hash table of all <em/StoreEntry/'s.  The
+	keys for the hash table are MD5 checksums of the objects
+	URI.  In addition there is also a doubly-linked list of
+	<em/StoreEntry/'s used for the LRU replacement algorithm.
+	When an entry is accessed, it is moved to the head of the
+	LRU list.  When Squid needs to replace cached objects, it
+	takes objects from the tail of the LRU list.
+
+	<P>
+	Objects are saved to disk in a two-level directory structure.
+	For each object the <em/StoreEntry/ includes a 4-byte
+	<em/fileno/ field.  This file number is converted to a disk
+	pathname by a simple algorithm which evenly distributes
+	the files across all cache directories.  A cache swap file
+	consists of two parts: the cache metadata, and the object
+	data.  Note the object data includes the full HTTP
+	reply---headers and body.  The HTTP reply headers are not
+	the same as the cache metadata.
+
+	<P>
+	Client-side requests register themselves with a <em/StoreEntry/
+	to be notified when new data arrives.  Multiple clients
+	may receive data via a single <em/StoreEntry/.  For POST
+	and PUT request, this process works in reverse.  Server-side
+	functions are notified when additional data is read from
+	the client.
+
+<sect1>Request Forwarding
+
+<sect1>Peer Selection
+
+	<P>
+	These functions are responsible for selecting one (or none)
+	of the neighbor caches as the appropriate forwarding
+	location.
+
+<sect1>Access Control
+
+	<P>
+	These functions are responsible for allowing or denying a
+	request, based on a number of different parameters.  These
+	parameters include the client's IP address, the hostname
+	of the requested resource, the request method, etc.  Some
+	of the necessary information may not be immediately available,
+	for example the origin server's IP address.  In these cases,
+	the ACL routines initiate lookups for the necessary
+	information and continues the access control checks when
+	the information is available.
+
+<sect1>Network Communication
+
+	<P>
+	These are the routines for communicating over TCP and UDP
+	network sockets.  Here is where sockets are opened, closed,
+	read, and written.  In addition, note that the heart of
+	Squid (<tt/comm_select()/ or <tt/comm_poll()/) exists here,
+	even though it handles all file descriptors, not just
+	network sockets.  These routines do not support queuing
+	multiple blocks of data for writing.  Consequently, a
+	callback occurs for every write request.
+
+<sect1>File/Disk I/O
+
+	<P>
+	Routines for reading and writing disk files (and FIFOs).
+	Reasons for separating network and disk I/O functions are
+	partly historical, and partly because of different behaviors.
+	For example, we don't worry about getting a ``No space left
+	on device'' error for network sockets.  The disk I/O routines
+	support queuing of multiple blocks for writing.  In some
+	cases, it is possible to merge multiple blocks into a single
+	write request.  The write callback does not necessarily
+	occur for every write request.
+
+<sect1>Neighbors
+
+	<P>
+	Maintains the list of neighbor caches.  Sends and receives
+	ICP messages to neighbors.  Decides which neighbors to
+	query for a given request.  File: <tt/neighbors.c/.
+
+<sect1>IP/FQDN Cache
+
+	<P>
+	A cache of name-to-address and address-to-name lookups.
+	These are hash tables keyed on the names and addresses.
+	<tt/ipcache_nbgethostbyname()/ and <tt/fqdncache_nbgethostbyaddr()/
+	implement the non-blocking lookups.  Files: <tt/ipcache.c/,
+	<tt/fqdncache.c/.
 
-<P>
-<em/Files:/
-	<tt/objcache.c/, <tt/stat.c/
+<sect1>Cache Manager
 
-<P>
+	<P>
 	This provides access to certain information needed by the
 	cache administrator.  A companion program, <em/cachemgr.cgi/
 	can be used to make this information available via a Web
@@ -260,13 +208,9 @@
 	to information.  It does not provide a method for configuring
 	Squid while it is running.
 
-<sect2>Network Measurement Database
-
-<P>
-<em/Files:/
-	<tt/net_db.c/
+<sect1>Network Measurement Database
 
-<P>
+	<P>
 	In a number of situation, Squid finds it useful to know the
 	estimated network round-trip time (RTT) between itself and
 	origin servers.  A particularly useful is example is
@@ -283,13 +227,9 @@
 	aggregation is used to reduce the overall database size.  File:
 	<tt/net_db.c/.
 
-<sect2>Redirectors
+<sect1>Redirectors
 
-<P>
-<em/Files:/
-	<tt/redirect.c/
-
-<P>
+	<P>
 	Squid has the ability to rewrite requests from clients.  After
 	checking the access controls, but before checking for cache hits,
 	requested URLs may optionally be written to an external
@@ -298,53 +238,27 @@
 	Common applications for this feature are extended access controls
 	and local mirroring.  File: <tt/redirect.c/.
 
-<sect2>Autonomous System Numbers
+<sect1>Autonomous System Numbers
 
-<P>
-<em/Files:/
-	<tt/asn.c/
-
-<P>
+	<P>
 	Squid supports Autonomous System (AS) numbers as another 
 	access control element.  The routines in <tt/asn.c/
 	query databases which map AS numbers into lists of CIDR
 	prefixes.  These results are stored in a radix tree which
 	allows fast searching of the AS number for a given IP address.
-	
-<sect2>Asynchronous I/O Operations
-
-<P>
-<em/Files:/
-	<tt/async_io.c/, <tt/aiops.c/
-
-<P>
-	These routines in <tt/async_io.c/ and <tt/aiops.c/ 
-	implement blocking disk operations in a set of thread (child)
-	processes.
 
-<sect2>Configuration File Parsing
-
-<P>
-<em/Files:/
-	<tt/cf.data.pre/,
-	<tt/cf_gen.c/,
-	<tt/cf_parser.c/,
-	<tt/cache_cf.c/
+<sect1>Configuration File Parsing
 
-<P>
+	<P>
 	The primary configuration file specification is in the file
 	<tt/cf.data.pre/.  A simple utility program, <tt/cf_gen/,
 	reads the <tt/cf.data.pre/ file and generates <tt/cf_parser.c/
 	and <tt/squid.conf/.  <tt/cf_parser.c/ is included directly
 	into <tt/cache_cf.c/ at compile time.
 
-<sect2>Callback Data Database
-
-<P>
-<em/Files:/
-	<tt/cbdata.c/
+<sect1>Callback Data Database
 
-<P>
+	<P>
 	Squid's extensive use of callback functions makes it very
 	susceptible to memory access errors.  Care must be taken
 	so that the <tt/callback_data/ memory is still valid when
@@ -352,13 +266,9 @@
 	provide a uniform method for managing callback data memory,
 	canceling callbacks, and preventing erroneous memory accesses.
 
-<sect2>Debugging
-
-<P>
-<em/Files:/
-	<tt/debug.c/
+<sect1>Debugging
 
-<P>
+	<P>
 	Squid includes extensive debugging statements to assist in
 	tracking down bugs and strange behavior.  Every debug statement
 	is assigned a section and level.  Usually, every debug statement
@@ -373,70 +283,49 @@
 	probably sounds more complicated than it really is.
 	File: <em/debug.c/.  Note that <tt/debug()/ itself is a macro.
 
-<sect2>Error Generation
+<sect1>Error Generation
 
-<P>
-<em/Files:/
-	<tt/errorpage.c/
-
-<P>
+	<P>
 	The routines in <tt/errorpage.c/ generate error messages from
 	a template file and specific request parameters.  This allows
 	for customized error messages and multilingual support.
 
-<sect2>Event Queue
+<sect1>Event Queue
 
-<P>
-<em/Files:/
-	<tt/event.c/
-
-<P>
+	<P>
 	The routines in <tt/event.c/ maintain a linked-list event
 	queue for functions to be executed at a future time.  The
 	event queue is used for periodic functions such as performing
 	cache replacement, cleaning swap directories, as well as one-time
 	functions such as ICP query timeouts.
-	
-<sect2>Filedescriptor Management
-<P>
-<em/Files:/
-	<tt/fd.c/
 
-<P>
+<sect1>Filedescriptor Management
+
+	<P>
 	Here we track the number of filedescriptors in use, and the
 	number of bytes which has been read from or written to each
 	file descriptor.
 
 
-<sect2>Hashtable Support
-<P>
-<em/Files:/
-	<tt/hash.c/
+<sect1>Hashtable Support
 
-<P>
+	<P>
 	These routines implement generic hash tables.  A hash table
 	is created with a function for hashing the key values, and a
 	function for comparing the key values.
 
-<sect2>HTTP Anonymization
-<P>
-<em/Files:/
-	<tt/http-anon.c/
+<sect1>HTTP Anonymization
 
-<P>
+	<P>
 	These routines support anonymizing of HTTP requests leaving
 	the cache.  Either specific request headers will be removed
 	(the ``standard'' mode), or only specific request headers
 	will be allowed (the ``paranoid'' mode).
 
 
-<sect2>Internet Cache Protocol
-<P>
-<em/Files:/
-	<tt/icp_v2.c/,
-	<tt/icp_v3.c/
+<sect1>Internet Cache Protocol
 
-<P>
+	<P>
 	Here we implement the Internet Cache Protocol.  This 
 	protocol is documented in the RFC 2186 and RFC 2187.
 	The bulk of code is in the <tt/icp_v2.c/ file.  The 
@@ -445,23 +334,17 @@
 	a different version number and a slightly different message
 	format.
 
-<sect2>Ident Lookups
-<P>
-<em/Files:/
-	<tt/ident.c/
+<sect1>Ident Lookups
 
-<P>
+	<P>
 	These routines support RFC 931 ``Ident'' lookups.   An ident
 	server running on a host will report the user name associated
 	with a connected TCP socket.  Some sites use this facility for
 	access control and logging purposes.
 
-<sect2>Memory Management
-<P>
-<em/Files:/
-	<tt/mem.c/
+<sect1>Memory Management
 
-<P>
+	<P>
 	These routines allocate and manage pools of memory for
 	frequently-used data structures.  When the <em/memory_pools/
 	configuration option is enabled, unused memory is not actually
@@ -469,23 +352,17 @@
 	in more efficient use of memory at the expense of a larger
 	process size.
 
-<sect2>Multicast Support
-<P>
-<em/Files:/
-	<tt/multicast.c/
+<sect1>Multicast Support
 
-<P>
+	<P>
 	Currently, multicast is only used for ICP queries.   The
 	routines in this file implement joining a UDP 
 	socket to a multicast group (or groups), and setting
 	the multicast TTL value on outgoing packets.
 
-<sect2>Persistent Server Connections
-<P>
-<em/Files:/
-	<tt/pconn.c/
+<sect1>Persistent Server Connections
 
-<P>
+	<P>
 	These routines manage idle, persistent HTTP connections
 	to origin servers and neighbor caches.  Idle sockets
 	are indexed in a hash table by their socket address
@@ -494,68 +371,50 @@
 	15 seconds.  After 15 seconds, idle socket connections
 	are closed.
 
-<sect2>Refresh Rules
-
-<P>
-<em/Files:/
-	<tt/refresh.c/
+<sect1>Refresh Rules
 
-<P>
+	<P>
 	These routines decide wether a cached object is stale or fresh,
 	based on the <em/refresh_pattern/ configuration options.
 	If an object is fresh, it can be returned as a cache hit.
 	If it is stale, then it must be revalidated with an	
 	If-Modified-Since request.
 
-<sect2>SNMP Support
-<P>
-<em/Files:/
-	<tt/snmp.c/,
-	<tt/snmp_agent.c/,
-	<tt/snmp_config.c/,
-	<tt/snmp_vars.c/
+<sect1>SNMP Support
 
-<P>
+	<P>
 	These routines implement SNMP for Squid.  At the present time,
 	we have made almost all of the cachemgr information available
 	via SNMP.
 
-<sect2>URN Support
-<P>
-<em/Files:/
-	<tt/urn.c/
+<sect1>URN Support
 
-<P>
-We are experimenting with URN support in Squid version 1.2.  Note,
-we're not talking full-blown generic URN's here. This is primarily
-targeted towards using URN's as an smart way of handling lists of
-mirror sites.  For more details, please see
-<url	url="http://squid.nlanr.net/Squid/urn-support.html"
+	<P>
+	We are experimenting with URN support in Squid version 1.2.
+	Note, we're not talking full-blown generic URN's here. This
+	is primarily targeted towards using URN's as an smart way
+	of handling lists of mirror sites.  For more details, please
+	see <url        url="http://squid.nlanr.net/Squid/urn-support.html"
 	name="URN support in Squid">.
 
 
-<sect1>External Programs
+<sect>External Programs
 
-<sect2>dnsserver
-<P>
-<em/Files:/
-	<tt/dnsserver.c/
+<sect1>dnsserver
 
-<P>
-    Because the standard <tt/gethostbyname(3)/ library call blocks,
-    Squid must use external processes to actually make these calls.
-    Typically there will be ten <tt/dnsserver/ processes spawned from
-    Squid.  Communication occurs via TCP sockets bound to the loopback
-    interface.  The functions in <tt/dns.c/ are primarily concerned
-    with starting and stopping the dnsservers.  Reading and writing to
-    and from the dnsservers occurs in the IP and FQDN cache modules.
+	<P>
+	Because the standard <tt/gethostbyname(3)/ library call
+	blocks, Squid must use external processes to actually make
+	these calls.  Typically there will be ten <tt/dnsserver/
+	processes spawned from Squid.  Communication occurs via
+	TCP sockets bound to the loopback interface.  The functions
+	in <tt/dns.c/ are primarily concerned with starting and
+	stopping the dnsservers.  Reading and writing to and from
+	the dnsservers occurs in the IP and FQDN cache modules.
 
-<sect2>pinger
-<P>
-<em/Files:/
-	<tt/pinger.c/
+<sect1>pinger
 
-<P>
+	<P>
 	Although it would be possible for Squid to send and receive
 	ICMP messages directly, we use an external process for
 	two important reasons:
